<!DOCTYPE html>

<?php

    define ("DB_HOST", "localhost:3310");
    define ("DB_NAME", "harcuond");
    define ("DB_USER", "root");
    define ("DB_PASSWD", "");
    
    $link = mysqli_connect(DB_HOST, DB_USER, DB_PASSWD);
    if (!$link) {
      echo "Nepodarilo se spojit s DB.";
      echo mysqli_connect_error();
      exit();
    }
    // pokusim se vybrat si spravnou databazi
    $success = mysqli_select_db($link, DB_NAME);
    if (!$success) {
      echo "Nepodařilo se přepnout na správnou databázi.";
      exit();
    }
    
    function loadItemList($link){
              $sqlQuery = "SELECT * FROM Message;";
              $result = mysqli_query($link, $sqlQuery);
              if ($result) {
                // iteruj vysledek a vypis ho na obrazovku
              while ($row = mysqli_fetch_assoc($result)) {
                    echo "<tr><td>";
                    echo $row['id'];
                    echo "</td><td>";
                    echo $row['author'];
                    echo "</td><td>";
                    echo $row['date'];
                    echo "</td><td>";
                    echo $row['title'];
                    echo "</td><td>";
                    echo $row['message'];
                    echo "</td><td>";
                    echo "<form action='".htmlspecialchars($_SERVER['PHP_SELF'])."' method='post'>";
                    echo "<input type='hidden' value='".$row['id']."' name='message-id'>";
                    echo  "<input type='submit' name='delete' value='Delete'/>";
                    echo "</form>";
                    echo "</td></tr>";
              }
              // uvoni resultset
              mysqli_free_result($result);
              }           
    }
    
    function storeNewMessage($link,$author,$title,$message){
      $date = date('Y-m-d H:i:s');
      
      $sqlInsertQuery = "INSERT INTO message(author,title,message,date) VALUES('$author','$title','$message','$date');";
      echo "<td>$sqlInsertQuery</td>";
      $result = mysqli_query($link, $sqlInsertQuery);
      echo $result;
    }

   $title = $author = $message ="";
   $titleErr = $authorErr = $messageErr = "";

  if ($_SERVER["REQUEST_METHOD"] == "POST") {
        if(isset($_POST["insert"])){
                 insertNewMessage($link);
        }else if(isset($_POST["delete"])){
                 deleteMessage($link,$_POST["message-id"]);
        }
  }
  
  function deleteMessage($link,$msgId){
      $sqlDeleteQuery = "DELETE FROM message WHERE id = $msgId;";
      $result = mysqli_query($link, $sqlDeleteQuery);
  }
  
  function insertNewMessage($link){
      $valid = true;
  
    if (empty($_POST["author"])) {
      $authorErr = "Author is required";
      $valid = false;
    }else {
      $author = clean_input($_POST["author"]);
    }
    
    if (empty($_POST["title"])) {
      $titleErr = "Title is required";
      $valid = false;
    }else {
      $title = clean_input($_POST["title"]);
    }
    
    if (empty($_POST["msg"])) {
      $messageErr = "Message is required";
      $valid = false;
    }else {
      $message = clean_input($_POST["msg"]);
    }
    
    if($valid){
      storeNewMessage($link,$author,$title,$message);
    }
  }
  
  function clean_input($data) {
    $data = trim($data);
    $data = stripslashes($data);
    $data = htmlspecialchars($data,ENT_QUOTES);
    return $data;
  }
?>

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <link rel="stylesheet" href="styl.css" type="text/css" />
	<title>Nastenka</title>
</head>

<body>
        
          <table>
            <thead>
              <tr><th>ID</th><th>Nadpis</th><th>Datum</th><th>Title</th><th>Message</th><th>Action</th></tr>
            </thead>
          
            <tbody>
              <?php loadItemList($link); ?>
            </tbody>
          
          </table>

        <form action="<?php echo htmlspecialchars($_SERVER["PHP_SELF"]);?>" method="post">
		      <fieldset id="info">
			     <legend>Základní údaje</legend>
			     <label for="title">Nadpis:<input type="text" id="title" name="title"/></label>
           <?php echo "<div> ".$titleErr."</div>"; ?>
		       <label for="author">Autor:<input type="text" id="author" name="author"/></label>
           <?php echo "<div> ".$authorErr."</div>"; ?>
          </fieldset>
               
          <fieldset id="message">
			      <legend>Zde napište Váš vzkaz:</legend>
			      <textarea id="msg" cols="60" rows="8" name="msg"></textarea>
            <?php echo "<div> ".$messageErr."</div>"; ?>
		      </fieldset>
		      <fieldset id="confirm">
			       <input type="submit" name="insert" value="Odeslat" />
			       <input id="del" type="reset" value="Vymazat" />
		      </fieldset> 
    </form>

</body>

<?php mysqli_close($link);?>